<?php
class Act extends Controller 
{
  
  function Act()
  {
    parent::Controller();
    $this->load->model('search_model');
    $this->output->cache(120);
  }
  
  function index()
  {
    $data['ajax_results'] = $this->search_model->ajaxSearch();
    $data['title'] = $this->title;
    $data['whereami'] = array("<a href='" . site_url() . "index.php/act/index'>Action</a>");
    
    if (isset($this->actrool))
      $data['actrool'] = $this->actrool;
    if (isset($this->email))
      $data['emailbool'] = $this->email;
    if (isset($this->force))
      $data['forcebool'] = $this->force;
    if (isset($this->test))
      $data['testbool'] = $this->test;
    if (isset($this->fromrepo))
      $data['fromrepo'] = $this->fromrepo;
    if (isset($this->torepo))
      $data['torepo'] = $this->torepo;

    $data['user'] = $this->getUser();
    if ($this->isPushInProgress() or $this->isUpdateDbInProgress())
      {
	$this->load->view('application/act', $data);
	return;
      }
    
    $queuelist = $this->getCookie();
    if ($queuelist === FALSE and $this->isPushInProgress() === FALSE and $this->isUpdateDbInProgress() === FALSE)
      {
	echo "Can't do anything. No packages in queue.";
	header('Refresh: 3; url=' . site_url('index.php'));
	return;
      }

    $pkglist = array();
    if ($queuelist)
      {
	$QResult = $this->search_model->SRCRPMs($queuelist);
	foreach ($QResult->SRPMs as $pkg)
	  {
	    $tmparr = explode(".src.rpm", $pkg->SRCRPM);
	    $pkglist[] = $tmparr[0];
	  }
	$data['pkgstring'] = implode(" ", $pkglist);
	$data['onqueue'] = sizeof($pkglist);
      }
    
    
    if ($data['user'])
      $this->load->view('application/act', $data);
    else
      {
	echo "You need to be logged in to access this feature.";
	header('Refresh: 3; url=' . site_url('index.php'));
      }
    
  }
  
  function submit()
  {
    $config = parse_ini_file(conf_file(), True);
    $allrepos = explode(" ", $config["repositories"]["allrepos"]);
    $dontpublishrepos = explode(" ", $config["repositories"]["dontpublishrepos"]);
    $publishrepos = $allrepos;
    foreach ($dontpublishrepos as $drepo)
      {
	$dkey = array_search($drepo, $publishrepos);
	if ($dkey !== False)
	  unset($publishrepos[$dkey]);
      }

    $this->actrool = $this->uri->segment(3, 0);
    $this->email = $this->uri->segment(4, 0);
    $this->force = $this->uri->segment(5, 0);
    $this->test = $this->uri->segment(6, 0);
    $this->fromrepo = $allrepos[$this->uri->segment(7, 0)];
    $this->torepo = $publishrepos[$this->uri->segment(8, 0)];
    
    $this->index();
  }
  
  function getCookie()
  {
    if (isset($_COOKIE['QueuedRPMs']) == False)
      return False;
    $queuelist = explode("s", $_COOKIE['QueuedRPMs']);
    
    for ($i=0; $i<sizeof($queuelist); ++$i)
      if (is_numeric($queuelist[$i]) == FALSE)
	unset($queuelist[$i]);
    
    return $queuelist;
  }

  function isPushInProgress()
  {
    if (file_exists("/var/lock/rutgers-repotools/pushpackage") or
	file_exists("/var/lock/rutgers-repotools/pullpackage") or
	file_exists("/var/lock/rutgers-repotools/movepackage"))
      return TRUE;
    else
      return FALSE;
  }

  function isUpdateDbInProgress()
  {
    if (file_exists("/var/lock/rutgers-repotools/populate-rpmfind-db"))
      return TRUE;
    else
      return FALSE;
  }
  
}
?>